MACRO language
--------------

Built on top of SCAT, this is a language that represents purely
concatenative code generators (macros).

This code is parameterized in target.ss, which provides 2 SCAT
functions 'compile' and 'literal' that produce postponed target
function calls and literal data loads.

It can be used all by itself for a purely concatenative Forth-like
language (The PURRR concatenative macro subset), or extended with
syntax (parsing words) to represent Forth code.

This package is part of the Staapl project, and contains the all the
files necessary to support automatic installation through PLaneT.
More information at

  http://planet.plt-scheme.org/display.ss?package=staapl.plt&owner=zwizwa

The full documentation, releases and darcs archive are available at

  http://zwizwa.be/staapl

Unless otherwise mentioned, all the files in this code tree are (c)
2006-2008 Tom Schouten, and subject to the terms of the GPL v2.  See
the file COPYING for more information.  Contact the author for
alternative licencing options.

PURRR language
--------------

An extension to the SCAT language to support Forth-like syntax
(parsing words) for the MACRO language with postponed code semantics.

This is the main vehicle used to implement the compiler for the PIC18
architecture.

FORTH language
--------------

An extension to the SCAT language to support Forth-like syntax
(parsing words). This is combined with the MACRO language to create
PURRR, but the idea is to keep it separate from the MACRO postponed
semantics to be able to represent Forth-like syntax on top of
scheme. The forth/lang folder implements a Forth layer on top of SCAT.

#lang scheme/base

;; Cleaned up version of a partial evaluator / concatenative language.

;; ROADMAP:

;;  * Port the pattern matching syntax to 1stack operation. This
;;    should be quite straightforward, only 'pattern-tx->macro'
;;    changes.
;;
;;  * Get the primitive macros to work (compile, literal)
;;
;;  * Split the current macro/ language into clean Coma and dirty
;;    Control macros.

POKE
----

A language on top of MACRO, either with flat Forth syntax, or
s-expression Joy-like syntax.

The main idea is to explore C code generation, and a minimal VM to run
real-time linear code. Target is 16/32-bit embedded systems and DSP.

The result of a "require" statement should be compilable C code.

SCAT language components
------------------------

   * rpn syntax transformer
   * state representation (stack + hidden)
   * prefix namespace management
   * scheme function snarfing
   * defining scat compositions


Highlevel interface
-------------------

   (scat: . <src>)

     Create an anonymous SCAT function.

   (compositions <ns> <compiler> . ((<name> . <src>) ...))

     Create a collection of function objects from source code <src>,
     and bind them to <name> in the namespace <ns>, using the compiler
     (<compiler> . <src>). The compiler handles the source namespace.

   (snarf <snarfer> <ns> . <spec>)

     Snarf functionality from scheme into namespace <ns> using the
     <snarfer> transformer.

\ pic18 analog->digital conversion

\ this is currently hardcoded for the CATkit board. i had some trouble
\ getting it to work, so i'm just following instructions.

\ 18LF1220: DS39605C p. 161
\ 18LF2620: DS39626C p. 223

macro
: ad-ready? ADCON0 GO_DONE low? ;
: init-ad   #b00111010 ADCON2 ! ;   \ left justified, 20 TAD, FOSC/32
forth

\ turn on the AD covertor
\ ref = VDD/VSS
\ ( channel -- )
: ad-channel! 7 and << << 1 or ADCON0 ! ;
: ad-start    ADCON0 GO_DONE high ;    

\ wait for a conversion to finish, then collect the high bits
: ad@-sync    begin ad-ready? until \ fallthrough
: ad@-nosync  ADRESH @ ;
    
: ad@
    ad-channel!
    ad-start
    ad@-sync ;

\ registers of interest:
\ ADCON1 for analog/digital select
\ TRISA/TRISB for input/output select
  

\ I2C serial bus driver

\ for 18f2620
macro

\ these need to be configured as in or out  
: i2c-clock TRISC 3 ;
: i2c-data  TRISC 4 ;
: output low ;
: input  high ;    
: master output ;
: slave  input ;  


    
: ic2-rx-ready? SSPSTAT

\ In slave mode both clock and data need to be input: the MSSP will
\ override to output state during transmission. In slave mode there is
\ always an interrupt on address match. It's possible to get
\ interrupts on start/stop bits too.

: init-ic2-master
    ic2-clock 
    #b00101000 SSPCON1 ! \ enable + master mode: clock = FOSC/(4 * (SSPADD + 1))

;

forth
  
\ blocking receive    
: ic2-receive
    begin ic2-rx-ready? until
    SSPBUF @ ;
    
\ SSPBUF = serial data I/O register    
\ SSPADD = device address
\ SSPCON1, SSPCON2, SSPSTAT = control registers  


\ Since I2C is a shared bus structure, it's easiest to interface to it
\ using a multi tasking / message passing approach. There are 2 levels:

\ - DRIVER: reads from message buffer, writes out to bus when ready
\ writes to message buffer, and wakes up tasks.

\ - TASK: a task maps a single message to zero or more output
\ messages. message sending never blocks.

    
    

\ deferred words

\ there is really no good solution here, since the problem i'm trying
\ to solve is really about coding style.

\ purrr uses an early binding strategy. what this means is that as
\ much as possible is fixed at compile time. combined with using flash
\ program storage, this makes programming code that can't entirely use
\ bottom up programming problematic. so

\ 1. early binding for optimized assembly code

\ 2. flash: write-once: no patching of code

\ 3. completely bottom up: code can only depend on earlier code, or
\    code defined in the same compilation unit.


\ this is usually ok for a finished product performing a well-defined
\ task. however, incremental developement often needs some plugin
\ (deferred) behaviour, otherwize you're stuck reloading code the
\ whole time. a good example is an interrupt service routine.

\ so, deferred words are very convenient. because of the restrictions
\ on flash memory, the only workable solution is to put addresses in
\ ram.

\ then remains the question on how to represent deferred
\ behaviour. the canonical way is to use code addresses. since the 18f
\ machines are 8bit, this is rather inconvenient. therefore i use an
\ indirect method. deferred behaviour is represented by 8bit execution
\ tokens (XTs), which are dereferenced using a ram table.

\ the ram table can be placed in a space which is not in the access
\ bank, so they don't compete with application global variables.

\ 1. XTs are 8bit
\ 2. table is defined in ram, preferrably in non-access memory
\ 3. calling clobbers the a register. (can be later removed)

\ some premature optimization urge: what about xt (functionality
\ encoded as byte) which does not need late binding (stored in flash)
\ ? this is already there in the form of 'route'


2 constant xt-bank \ bank in multiple of #x80

: xt>word \ xt -- lo hi
    rot<< dup >x
    #xFE and      \ mask 1111 1110   low byte
    x> 1 and ;    \ mask 0000 0001   high byte

: xt>addr \ xt -- lo hi
    xt>word xt-bank + ;

: execute \ xt -- ...
    xt>addr
    
: 2execute \ lo hi --
    push rh ! rl ! ;

\ see mem.f
: @@ @ @a+ ;
: !! swap ! !a+ ;    
    
: run-hook \ var --
    @@ 2execute ;
    

\ that's the easy part.. the hard part is getting the addresses in
\ place. for this 'defer' is handy. an occurance of a word could
\ translate to 'XT execute'. but, maybe a more direct approach is
\ better: do something like 'xt bla' to reserve an execution token,
\ and implement it as a constant.

\ predicates

: _=
    _-
: _0=    
    INDF0 iorwf
    z? if
        INDF0 setf
        -1 retlw
    then
        INDF0 clrf
        0 retlw
    
\ SIGNED

: _sign>flag-invert
    #x80 xor
: _sign>flag
    rot<< 1 and
    0 sublw
    INDF0 movwf ;

    
: _<   _-   _sign>flag ;
: _>=  _-   _sign>flag-invert ;

: _>   _-   _negate _sign>flag ;
: _<=  _-   _negate _sign>flag-invert ;
    

    
	
load vm-core.f        \ 14bit payload virtual machine
load double-math.f    \ arithmetic: these are straight from the STC library
load double-pred.f    \ predicates    
load mul16-global.f   \ multiplier with global temp state
load vm-mem.f         \ memory model
load stack-global.f   \ basic stack manips with global temp state
    

\ the nicest paradigm for controlling sounds is that of virtual
\ samples: splitting up the sound generation in two tasks gives a more
\ natural way of describing sound:
\
\  - virtual samples: infinite loops that describe the evolution of a
\    sound, using the sync mechanisms available.
\
\  - trigger controller: a task that can restart different virtual
\    samples, also using the sync mechanisms available.
\
\ the basic idea is to separate MODULATION from EVENTS.



\ We're only using 2 tasks, so just need one task variable to save the
\ suspended tasks' state pointer.

variable other-task  

: yield
    suspend
    other-task swaptask
    resume ;

\ The task switch point is the synchronization wait loop. This is the
\ same as the sync-tick macro from synth-control.f but with yielding
\ inserted in the loop.

macro    
: sync | bit | \ --
    begin yield bit tickbit low?  until
    begin yield bit tickbit high? until ;
forth    


\ Memory allocation for the virtual sample player task.

macro
: vsamp-rs #x10 ;  \ half of the hardware stack
: vsamp-ds #xE0 ;  \ DS and XS at top of memory (shadowed by SFRs)
: vsamp-xs #xF0 ;   
forth  
  

\ Booting a new virtual sample task. This basically executes a word in
\ a newly created context. This uses byte addressing for the task.

\ The current vsamp is stored in a vector, so it can be
\ retriggered. Just set it using the '->' word.
  
2variable sound

: bang \ --
    suspend other-task !  \ suspend the controller task
    vsamp-rs rp !         \ set the pointers
    vsamp-xs xp !
    vsamp-ds dp !
    sound invoke ;


\ utility
macro
: tail begin yield again ;
forth
    

\ -*- forth -*-

\ noise generators using polynomials in GF[2] modulo a prime P[x]

\   <n2>:<n1> contains coefficients of the current polynomial n[x]
\ 1:<c2>:<c1> are the coefficients of polynomial P[x]

\ the noise generator calculates n[x] -> x n[x] mod P[x], by performing
\ a shift, followed by a conditional XOR which performs the modulo.

\ setting the lower bits of c1 to zero allows the use of different
\ degrees then 16, giving GF[2^n] for all n <= 24

variable n0 variable n1 \ state
variable c0 variable c1 \ polynomial coefficients

macro

\ shift the register to carry
: rand-shift
    clc n0 rot<<c!
        n1 rot<<c! ;

\ perform modulo operation
: rand-fold
    c0 @ n0 xor!
    c1 @ n1 xor! ;

: rand>c
    rand-shift c? if rand-fold then ;

: init-rand
    \ init noise state: this the primitive polynomial mathematica
    \ gives for field = GF[65536]
    #xD7 c0 ! -1 n0 !
    #x50 c1 ! -1 n1 ! ;

\ fixed 8 bit rng TOS state update, constant duration == 3 cycles this
\ shaves off one cycle by using rotate, and cancelling out the bit if
\ it's one. the 0x1C below is from the polynomial 0x11D.

: rng<  rot<< odd? if 0x1C xor then ;

    
forth

: randbyte 0 8                      \ get 8 fresh random bits
: randbits for rand>c rot<<c next  ; \ accum bits -- accum    
: fastrand 0 1 randbits drop n1 @ ; \ take the top of the state bits as random

\ vm memory model.

\ there are a lot of design decisions here. one is already made above:
\ code cannot reside in ram. maybe that's a bad idea? another one is:
\ should STORE write flash memory? terribly convenient, but highly
\ inefficient.
	
\ since the vm has an effective word address range of 32kb, i'm going
\ to use the upper half for flash, and the lower half for ram. eeprom
\ could be added somewhere when necessary. 

macro
: ram? 1st 7 low? ;
forth

\ FETCH  

: flash-enter
    fh @ >x fl @ >x   \ save f
    fl ! fh ! ;

: flash-leave    
    x> fl ! x> fh @ ; \ restore f

: _@
    ram? if a!! @a+ @a+ ; then
    #x7F and

: _@_flash
    flash-enter
    @f+ @f+
    flash-leave 


: _@c
    ram? if a!! @a+ 0 ; then
: _@c_flash    
    flash-enter
    @f+ 0
    flash-leave ;

\ STORE

\ only mapped to ram.
: _!   a!! swap>x !a+ x> !a+ ;
: _!c  a!! drop !a+ ;

    

    

    

\ convert access bank address to real address in ah:al
: access>a
    dup al !
    #x80 xor rot<<c
    drop ah @ ah --! ;

\ FIXME: find a proper way to add library defers.
: ~@ access>a @a+ ;
: ~! access>a !a+ ;

\ 8x8 multiplication


\ UNSIGNED
\ rounds down
: u.* umul>PROD PRODH @ ;


\ SIGNED

\ Using the same approach for signed as 16x16: i can't figure out how
\ to do separate sign + fraction fast enough to compete with
\ conditional subtraction of cross terms. However, no extra memory
\ required.

\ Suppose X is negative. in that case what we're computing using the
\ unsigned multiplication is actually
\
\   (X + z) Y
\
\ this has a term z too much in the result, which needs to be
\ subtracted. same goes for Y being negative.

\ Core routine that can be reused for mixer core routine    

macro
: s8x8->16/PROD \ a b --
    2nd mulwf
    2nd 7 high?     if dup PRODH -! then
    rot<<c drop     \ sign is now in carry flag
    STATUS 0 high?  if dup PRODH -! then
    drop
    ;
forth  
    
\ Signed fractional multiplication. This uses s1.6 format, so 1 can be
\ represented. In s.7 the 1 will overflow to -1.
  
: .*
    s8x8->16/PROD
    save           \ undo drop
    
    PRODL rot<<c!
    PRODH rot<<c!
    
    PRODL rot<<c!
    PRODH rot<<c! d=w ;

\ Using this to generate exponentials: be careful about rounding
\ errors. It might b e wise to use a version that rounds towards zero
\ instead of down.
    


\ signed multiplication (X,Y) -> XY



\ using conditional subtraction:



\ signed fractional. this is the same as signed, but followed by a
\ shift.


: sat-16->8
    >x              \ save high byte
    dup rot<< 1 and \ get sign bit
    x@ +            \ add high byte (dup to prevent drop)
    z? if
        xdrop drop ;
    then
    drop x>
    rot<<c drop
    c? if
        drop #x80 ;
    then
        drop #x7F ; 

\ A static 15 byte buffer queue.

\ A buffer consists of:
\   - a variable containing [ read | write ] pointers (nibbles)
\   - base pointer (one 16 bit line of ram)

\ The idea is to use a set of macros to instantiate specialized words
\ that read and write from a buffer + macros for empty? and full?
\ status.


macro
: buffer.read  | RW base |
    base 2 lfsr
    RW @ rw-read RW ! ;

: buffer.write | RW base |
    base 2 lfsr
    RW @ rw-write RW ! ;

: buffer.empty? | RW base |
    RW @ rw-empty>z z? ;

: buffer.full? | RW base |
    RW @ #x10 - rw-empty>z z? ;
: buffer.size  | RW base |
    RW @ rw-size ;
forth

\ Re-usable core routines for the macros above. These assume the a
\ register is set to the base of the buffer.

: rw-read   \ RW -- byte RW+
    dup >x
    #xF0 and swap-nibble
    al +! @a+
    x> #x10 + ;
    
: rw-write  \ byte RW -- RW+
    dup >x
    #x0F and al +! !a+
    x> 1 + ;

: rw-size \ RW
    dup swap-nibble - #x0F and ;
    
    
: rw-empty>z \ RW
    rw-size
    nfdrop ;    

\ Macros for generic 2^n byte buffers that can be specialized with
\ static knowledge, because indirect access is expensive on PIC, and
\ buffers usually need to be fast. Statically known data:
\  - base address
\  - size (specified as bitmask)
\  - state: location of read / write pointers: sequential byte variables

\ Read and write pointers are distinct to ensure proper concurrent
\ access.

\ Note that this code is optimized for speed and not code size: it's
\ up to you to instantiate some words manually if you think
\ 'buffer.read/yield' and 'buffer.read/write' give too much machine
\ code.


macro

: a! 2 lfsr ;   \ set literal (large) value in a reg  
: buffer.index | mask | @ mask and al +! ;
: p.read ;
: p.write 1 + ;    

\ ops on buffer data
    
: buffer.read  | base p mask |
    base a!
    p p.read mask buffer.index @a
    p p.read 1+! ;
    
: buffer.write | base p mask |
    base a!
    p p.write mask buffer.index !a
    p p.write 1+! ;

\ ops on pointers only. note that size takes the actual pointers, not
\ the masked ones.

: p.size | p |
    p p.write @
    p p.read @ - ;
    
: buffer.size | base p mask |
    p p.size ;

\ check if both pointers are the same    
: buffer.empty>z | base p mask |
    p p.write @
    p p.read @ xor nfdrop ;

\ check if no overflow has occured (high bits of size are 0)
: buffer.room>z | base p mask |
    p p.size mask
    #xFF xor and   
    nfdrop ;

: buffer.clear | base p mask |
    0 p p.read !
    0 p p.write ! ;

\ macros not using the expanded >z procedures

: buffer.empty? buffer.empty>z z? ;    
: buffer.room?  buffer.room>z z? ;    


\ transfers: assuming there is a 'yield' operation (which might be a
\ busy loop) a transfer macro can be constucted.

: buffer.read/yield | b p m |
    begin b p m buffer.empty? while yield repeat
    b p m buffer.read ;

: buffer.write/yield | b p m |
    begin b p m buffer.full? while yield repeat
    b p m buffer.write ;


    
\ constructors
    
\ : compile-buffer pre- base mask |
    
    

    
forth

\ not a module, needs 'load' to define undefined symbols
\ -*- forth -*-


\ neeed to be provided by users
\ declare console-on
\ declare console-off
\ declare receive
\ declare transmit
\ declare hello


\ --- INTERPRETER ---

\ control xts
: jsr    push receive TOSL ! receive TOSH ! ;
: ack    0 transmit ;  \ zero length message


\ NOTE: console-on/off is disabled. fix this somewhere else.    
: ferase   flash erase   ack ;
: fprog    flash program ack ;


\ token 0 is nop, so a stream of zeros can be used as soft interrupt

\ Except for nop and reset, all tokens return at least one byte result
\ to synchronize on. The protocol has Remote Procedure Call (RPC)
\ semantics, but implements it without the need for simultaneous
\ buffering and handling.
    
\ token --
: interpret
    #x0F and route
     ack     ., receive/ack  ., 1/transmit ., jsr/ack .,
     lda     ., ldf          ., ack        ., reset
     n@a+    ., n@f+         ., n!a+       ., n!f+    .,    
     chkblk  ., ack          ., ferase     ., fprog   ;


: 1/transmit  1 transmit transmit ;
: receive/ack receive ack ;
: jsr/ack     jsr ack ;    
        
\ Bytecode interpreter main loop.  The zero length message is ignored,
\ all other messages are interpreted and assumed to be of correct
\ length.  ( This is debug: target doesn't need to second-guess the host. )

macro
: 0=  #xFF + drop nc? ;
forth
    
: interpreter
    receive 0= not if receive interpret then
    interpreter ;

\ Block transfer. These take the size from the command input to make
\ the host -> target protocol context-free, and send out message
\ length to do the same for target -> host protocol.

: receive-dup-transmit receive dup transmit ;
    
: n@f+ receive-dup-transmit for @f+ transmit next ;
: n@a+ receive-dup-transmit for @a+ transmit next ;
    
: n!f+ receive for receive !f+ next ack ;
: n!a+ receive for receive !a+ next ack ;

\ pointer initialization
: lda  receive receive a!! ack ;
: ldf  receive receive f!! ack ;
    
\ program block memory check
: chkblk 255 64 for @f+ and next 1 transmit transmit ;

\ chip constants

load p18f2550-const.f

\ chip config macros for core code

macro
: serial-div 4 ;

: init-chip
    3-output ;

: init-serial
    TRISC 7 high TRISC 6 low  \ pin tristate
    init-serial-baud-16 ;     \ 16 bit timer using serial-div defined above

forth

\ For PIC18, execute doesn't make much sense: 8 bit address space
\ doesn't bring you very far. However, the 16 bit version does make
\ sense.

\ So let's define an execution token as a 8 byte value. Does this lead
\ to trouble?

\ Note that the value of a symbol representing a code address always
\ uses WORD ADDRESSING unless otherwise indicated. This is different
\ from table reading and writing, which uses BYTE ADDRESSING. I found
\ this to be the sanest way of dealing with addresses. It's a
\ trade--off slightly in favour if this solution.

\ As a result, _execute does need to shift its arguments.

macro
: lohi dup #xFF and swap 8 >>> ;
forth  

: runtime-execute              \ the macro fallback
: execute/w 2nd rot<<c! rot<<c \ the LSB is ignored by the machine..
: execute/b push rh ! rl ! ;   \ ( lo hi -- ) execute STC primitive, byte address

\ -*- forth -*-

\ Serial port driver, no interrupts.

\ currently supported devices:
\ original 18f252.

\ new 18f1220. extra features not present in old design, and not used
\ here. everything else, except the location of the pins, is the same.

\ - TXSTA SENDB
\ - BAUDCTL
\ - 16bit baud gen (default is 8 bit)
\ - autobaud


\ use partial evaluation to compute the baud count. note that for high
\ clock rates and low baud rates, this needs a 16bit baud rate
\ generator (or using the 64 division instead of 16)

\ parameter RCSTA
\ parameter CREN
\ parameter OERR
\ parameter FERR
\ parameter PIR1
\ parameter RCIF
\ parameter TXSTA
\ parameter TRMT
\ parameter RCREG
\ parameter TXREG
\ parameter SPBRG
\ parameter SPBRGH
\ parameter BAUDCON

\ driver code
macro
: async.rx-reset
    RCSTA CREN low
    RCSTA CREN high ;
: async.overrun?   RCSTA OERR high? ;
: async.frame?     RCSTA FERR high? ;
forth


macro  
: async.rx-ready? PIR1  RCIF high? ;
: async.tx-ready? TXSTA TRMT high? ;
forth

: async.rx>
    begin async.rx-ready? until
    async.overrun? if
        async.rx-reset
        async.rx> ;
    then
    RCREG @
    async.frame? if
        drop
        async.rx> ;
    then ;

: async.>tx
    begin async.tx-ready? until TXREG ! ;



macro

\ parameter  serial-div
\ parameter  fosc
\ parameter  baud

: baud>count >m fosc m> serial-div * / 1 - ;
: baud-count baud baud>count ;
  
\ not all machines have the 16 bit BRG, for example the older 252 and
\ 452 models. for newer (4-digit?) chips the 16bit timer can be used.

: init-serial-baud-8
    baud-count SPBRG !
    #x24 TXSTA !               \ enable transmission and high baud rate
    #x90 RCSTA !               \ enable serial port and reception
;



\ send out all ones, which gives a pattern 0 11111111 1... which can
\ be easily measured with a frequency counter to see if the rate is
\ right. frequency = baud rate / 10
    
: debug-transmit
    begin
        #xFF
        transmit again ;

: debug-loopback
    begin receive transmit again ;

forth
  

\ 16 bit 1-pole lowpass filter. implements:
\
\   x += a (u - x)
\
\ where a < 2^(-8). more specificly a = .00AA (2 HEX digits)
\
\ internally, the filter has 24 bit precision to prevent roundoff
\ errors, and one byte containing an unsigned filter coeff.

\ suppose the state X is in 8.16 fixed point. this gives the values:
\ x(z) = x0 + x1 z^-1 + x2^z-2
\ u(z) = u0 + u1 z^-1 + u2^z-2 
\ d(z) = d0 + d1 z^-1           = u(z) - x(z)
\ a(z) = a0 z^-2

\ from this follows that the low byte of d(z)a(z) can be dropped (or
\ could be used to round?) and the rest is straighforward.

\ sign correction is for (d0 + z) + d1 z^(-1), which is z * a0^z-2 =
\ a0 * z^-1


\ temp vars for all filters: use vars used by multiplier.
macro
: D0 X0 ;  \ difference (u - x)
: D1 X1 ;    

: lpf/int-common | state |    
    \ perform unsigned8 * unsigned16 multiplication + accumulation
    D0 @ state 3 + mulwf drop
    PRODL rot<<c!              \ get carry bit for rounding
    PRODH @ state 0 + ++!
          0 state 1 + ++!
          0 state 2 + ++!
         
    D1 @ state 3 + mulwf drop
    PRODL @ state 0 + +!
    PRODH @ state 1 + ++!
          0 state 2 + ++!

    \ perform signed correction
    D1 7 high? if
        state 3 + @ state 1 + -!
                  0 state 2 + --!
    then ;

\ ul uh state --
: lpf-tick | state |

    \ compute difference
    D1 ! D0 !
    state 1 + @ D0 -!
    state 2 + @ D1 --!

    state lpf/int-common ;

\ same as above, but as integrator: no state decay.
    
\ ul uh state --
: int-tick | state |

    \ store input
    D1 ! D0 !
    state lpf/int-common ;

    
: lpf-out | state |
    \ get value
    state 1 + @
    state 2 + @ ;

\ coef state --
: lpf-init | state |
    state 3 + !       \ save coef
    0 state !         \ zero state vector
    0 state 1 + !
    0 state 2 + ! ;
forth

\   2variable lp
\   2variable lp__
  
\ : _filter-init  #x80 lp lpf-init ;
\ : _filter-tick  lp lpf-tick ;
\ : _filter-out   lp lpf-out ;
    
\ : _filter-0ntick
\     for 0 0 _filter-tick next ;
    
    
    

\ -*- forth -*- 



\ flash/eeprom/config programming

macro

\ parameter GIE
\ parameter INTCON
\ parameter EECON1
\ parameter CFGS
\ parameter EEPGD
\ parameter EECON2
\ parameter WR
\ parameter WREN
\ parameter FREE

\ interrupts
: cli        INTCON GIE low ;              \ disable interrupts
: sti        INTCON GIE high ;             \ enable interrupts

\ target select
: config        EECON1 CFGS high ;
: eeprom        EECON1 EEPGD low EECON1 CFGS low ;
: flash         EECON1 EEPGD high EECON1 CFGS low ;

forth

\ engage in write / erase
\ apparently, setting the WR bit high needs to follow
\ immediately after the 0x55 0xaa sequence
: engage
    dup cli

    #x55 movlw EECON2 movwf 
    #xAA movlw EECON2 movwf

    EECON1 WR high sti drop ;

\ action
: erase         EECON1 WREN high EECON1 FREE high engage ;
: program       EECON1 WREN high EECON1 FREE low 
		tblrd*- engage 
		tblrd*+ ;
 
\ now we have:
\ 'flash program'   -> programs 8 bytes flash in holding registers
\ 'flash erase'     -> erase 64 bytes flash
\ 'eeprom program'  -> program one byte eeprom
\ 'config program'  -> program one byte config

\ 16 bit 1-pole lowpass filter. implements:
\
\   x += a (u - x)
\
\ internally, the filter has 24 bit precision to prevent roundoff
\ errors, and one byte containing an unsigned filter coeff.

\ suppose the state S is in 8.16 fixed point. this gives the values:
\ s(z) = s0 + s1 z^-1 + s2^z-2
\ u(z) = u0 + u1 z^-1 + u2^z-2 
\ d(z) = d0 + d1 z^-1           = u(z) - x(z)
\ a(z) = a1 z^-1 + a2 z^-2

\ from this follows that the low byte of d(z)a(z) can be dropped (or
\ could be used to round?) and the rest is straighforward.

\ sign correction is for (d0 + z) + d1 z^(-1), which is

\ z * (a1 z^-1 + a2 z^-2) = a1 + a2 * z^-1

\ temp vars for all filters: use vars used by multiplier.
\ note that the indices correspond to NEGATIVE z powers.

macro
: D0 X0 ;  \ difference (u - x)
: D1 X1 ;    

: A2 3 + ;
: A1 4 + ;    

: S2 0 + ;    
: S1 1 + ;
: S0 2 + ;
    
: lpf/int-common | state |    
    \ perform unsigned8 * unsigned16 multiplication + accumulation
    D1 @ state A2 mulwf drop
    PRODL rot<<c!              \ get carry bit for rounding
    PRODH @ state S2 ++!
          0 state S1 ++!
          0 state S0 ++!
         
    D0 @ state A2 mulwf drop
    PRODL @ state S2 +!
    PRODH @ state S1 ++!
          0 state S0 ++!

    D1 @ state A1 mulwf drop
    PRODL @ state S2 +!
    PRODH @ state S1 ++!
          0 state S0 ++!
    
    D0 @ state A1 mulwf drop
    PRODL @ state S1 +!
    PRODH @ state S0 ++!

    \ perform signed correction: has got 100 * 0.A1A2 = A1.A2 too much.
    D0 7 high? if
        state A2 @ state S1 -!
        state A1 @ state S0 --!
    then ;

\ ul uh state --
: lpf-tick | state |

    \ compute difference
    D0 ! D1 !
    state S1 @ D1 -!
    state S0 @ D0 --!

    state lpf/int-common ;

\ same as above, but as integrator: no state decay.
    
\ ul uh state --
: int-tick | state |

    \ store input
    D0 ! D1 !
    state lpf/int-common ;

    
: lpf-out | state |
    \ get value
    state S1 @
    state S0 @ ;

\ coefl coefh state --
: lpf-init | state |
    state A1 !
    state A2 !       \ save coef
    0 state S2 !     \ zero state vector
    0 state S1 !
    0 state S0 ! ;
forth

\   2variable lp
\   2variable lp__
  
\ : _filter-init  #x80 lp lpf-init ;
\ : _filter-tick  lp lpf-tick ;
\ : _filter-out   lp lpf-out ;
    
\ : _filter-0ntick
\     for 0 0 _filter-tick next ;
    
    
    

\ -*- forth -*-

\ This is an example Forth file for the 18f1220 chip with serial
\ connection.

\ config bits
\ internal oscillator, watchdog disabled
#x300000 org
 #x00 , #xC8 , #x0F , #x00 ,  \ 0 1 2 3
 #x00 , #x80 , #x80 , #x00 ,  \ 4 5 6 7
 #x03 , #xC0 , #x03 , #xA0 ,  \ 8 9 A B    \ B : boot protect on / off = #xA0 / #xE0
 #x03 , #x40 ,                \ C D


macro

\ time
: fosc 8000000 ;
: baud 9600 ;

\ memory
: stack-data    #x80 ;
: stack-control #x90 ;
: allot-ram     #x00 ;
: app-boot      #x200 ;    
: allot-flash   #x240 ;  \ reserve 1 block for isr code
: read-buffer   #xA0 ;   \ default for terminal.f
forth


load p18f1220.f         \ chip macros
load monitor-serial.f   \ boot: shared serial monitor/interpeter code

: init-all-but-rs
    init-ds         \ data and aux/control stack
    init-xs
    init-chip ;     \ setup outputs and clock

    
macro    
: init-all    
    init-rs           \ setup RS needs to be macro
    init-all-but-rs   \ can be shared for alternative reset vector
    init-serial       \ init serial port RX/TX logic    
    ;
forth


fstring: hello pic18  \ string constant

: warm
    init-all
    \ debug-transmit
    \ debug-loopback
    \ interpreter ;
    debug-serial? if interpreter ; then application ; 


allot-flash org

\ serial terminal I/O with XON/XOFF

\ to keep things simple, we will tokenize on receive. all dictionary
\ words will be truncated to (let's say) 8 characters, so there's no
\ need for large buffers. so:

\ * 'read' which read in a single word, delimited by whitespace.
\ * leading whitespace is removed
\ * flow control is per word: X is always OFF outside of 'read'
\ * I/O is half duplex

\ Wikipedia says:

\ the XON/XOFF protocol is controlled by the recipient of the data
\ being transferred. receiver sends XOFF when it can't take any more
\ data, and sends XON when it's ready again.


19 constant XOFF \ #x13
17 constant XON  \ #x11


\ the constants 'read-buffer' and 'read-size-mask' need to be
\ defined. the buffer is a standard forth string: first byte is
\ size. to simplify the buffer needs to be aligned and a power of 2
\ size.

\ buffer code. the 'a' register contains buffer base. if buffer is
\ full, data is not written.

: a->read-buffer
    #xA0 #x00 a!! ;

: read-size-current
    al @ read-size-mask and ;
  
: read-record  \ byte --
    read-size-current
    read-size-mask
      = if drop ; then  \ ignore because full
    !+a ;               \ store in buffer

: read-finish \ --
    read-size-current
    a->read-buffer !a ; \ store size byte

\ interpret backspace and special characters    
: read-record/interpret
    read-record ;


: read
    XON transmit read-word
    XOFF transmit ;


\ zero terminated list of whitespace chars
: f->whitespaces  f->  9 , 10 , 13 , 0 ,
  
: white? \ char - char ?
    f->whitespaces
    begin
	@f++
	z? if drop 0 ; then   \ exhausted: no whitespace
	=? if drop -1 ; then  \ found whitespace
	drop
    again ;
  
: read-word
    a->read-buffer

    \ state A: skip leading whitespace
    receive
    white? if
	drop read-word ;
    then
    read-record/interpret

    \ state B: whitespace delimits word
    begin
	receive
	white? if
	    drop  \ whitespace ends
	    read-finish ;
	then
	read-record/interpret
    again ;

\ debug routines

load cm.f \ use compiled macros


\ wait, but reset when bytes are arriving on the port

: rint  receive interpret ;

: pause 0 for 0 for
	    rx-ready? if reset then
	next next ;

    

\ chip constants
load p18f2620-const.f

macro

\ Chip supports 16 and 64 bit dividers. We're using an 8 bit
\ resolution divider, which has a constant 16 factor.
  
: serial-div 16 ;

\ Chip config macros for core code

: init-chip
    -1 LATC !        \ prevent TX pin glitch
    #x70 OSCCON ! ;  \ internal oscillator at 8MHz



\ Detect the presence of a serial cable by detecting an IDLE state
\ (high) on RX (RC7). Tie the pin low using 100k to default to BREAK
\ with no cable connected, or jumper it.

\ This macro is only valid AFTER initializing the serial port, which
\ sets the inputs to digital.
    
: debug-serial?
    PORTC 7 high? ;
    
: init-serial
    \ see DS39626C-page 211
    #b11000000 TRISC or!         \ pin config
    init-serial-baud-8           \ like other pics
    ;

\ A/D converter
\ DS39626C p. 224

\ Ports are configured as analog using a range, not by individual
\ ports. This a bit awkward, so do this manually in the app.


    
forth

  

\ sheepsint audio core module

macro
: OSC0-enable INTCON TMR0IE ;
: OSC1-enable PIE1   TMR1IE ;
: OSC2-enable PIE2   TMR3IE ;
: OSCF-enable PIE1   TMR2IE ;

: OSC0-flag INTCON TMR0IF ;
: OSC1-flag PIR1   TMR1IF ;
: OSC2-flag PIR2   TMR3IF ;
: OSCF-flag PIR1   TMR2IF ;
forth    

\ fixed tick counter for binary time base : control locks here
variable tick0
variable tick1
variable tick2
variable tick3

\ oscillator periods
variable posc0l variable posc0h
variable posc1l variable posc1h
variable posc2l variable posc2h

\ sample period
variable psample

\ synth flags
variable synth

\ 01 mixer : needs to be the same as 'mix'
macro  
: mix:silence 0 ;
: mix:xmod    1 ;
: mix:reso    2 ;
: mix:osc1    3 ;
forth    

macro  
: sync:0->1  4 ;
: sync:0->2  5 ; \ will put 2 in one-shot mode
: sync:1->2  6 ;
: osc1:noise 7 ; \ osc1 noise/square switch
forth  

\ the ordering here is just so we can piggyback on full adder compute
\ use easy osc0 xor [osc1 and osc2]
variable osc-bus
macro
: bus:0 osc-bus 2 ;
: bus:1 osc-bus 1 ;
: bus:2 osc-bus 0 ;
forth
  
\ output buffer -- FIXME: really needed?
variable output-buffer
macro  
: output output-buffer 0 ;
forth


macro

: mixer       3 and ;  \ synth -- mixer
  
: output<c    output-buffer rot<<c! ;

: AUDIO+      LATB 3 ;
: AUDIO-      LATB 2 ;

: init-out
    TRISB 2 low
    TRISB 3 low ;
    
\ : speaker-on  #x0C LATB or! ;
\ : speaker-off #xF3 LATB and! ;    

: speaker-on    AUDIO- low AUDIO+ high ;
: speaker-off   AUDIO- low AUDIO+ low ;    


    
forth

\ sample player
variable sample-bits
variable sample-bucket
variable sample-lo
variable sample-hi

\ control
variable pole

  
\ rng
load lfsr.f
  

\ SYNTH


\ oscillator updates:
\   restart is ran once / cycle to ADD to the timer, so the period is
\   stable no matter when in the cycle this routine is called. updates
\   assume no carry : handled within 247 counts from interrupt

: restart0
    TMR0L @      \ read low timer value. this also latches the high byte.
    9 +          \ 7 = space between updates, 2 = TMR0 delay
    posc0l @ +   \ advance timer lo, write carry bit
    posc0h @     \ read timer high increment on stack
    TMR0H ++!    \ update timer high latch
    TMR0L ! ;    \ write out timer lo, which also writes the latched high byte.
    
\ same as TMR0, only TMR1/TMR3 do not have a 2 cycle delay after write.
    
: restart1 TMR1L @ 7 + posc1l @ + posc1h @ TMR1H ++! TMR1L ! ;
: restart2 TMR3L @ 7 + posc2l @ + posc2h @ TMR3H ++! TMR3L ! ;

\ oscillator updates: reset really resets a timer. also clear
\ interrupt flag to kill pending interrupts.

: reset0 posc0h @ TMR0H ! posc0l @ TMR0L ! ;
: reset1 posc1h @ TMR1H ! posc1l @ TMR1L ! ;
: reset2 posc2h @ TMR3H ! posc2l @ TMR3L ! ;


\ mix bus to audio output
: bus>audio
    mix
: click
    output high? 
    if speaker-on ; then
    speaker-off ;
    

\ output mixers
 

\ reso filter emulation: this requires some explanation.

\ the output = [osc0] toggled by [osc1 and osc2]
\ the and operation combines the reso response [osc1] with an envelope [osc2]
\ this consists of the transient response, which is added to [osc0]

\ the 'and' operation is symmetric, so which of both inputs is the
\ envelope depends on the triggering mechanism: [osc2] is one shot if
\ it is synced to [osc0]
    
\ now, in order to compute this, i use the fact that the bits are ordered as
\ [osc0] : [osc1] : [osc2]

\ adding 1 to this will use the binary addition logic to carry over
\ the bit in case both [osc1] and [osc2] are one, so the result of
\ [osc1 and osc2] is xored with osc0.

    
: mix-reso
    osc-bus @ 1+  \ perform logic op
    rot>> rot>>   \ get result bit in LSB
    output-buffer ! ;
    

\ and a hack for xmod
\ [osc2] is copied by shifting it into output reg
\ [osc1] is shifted to carry flag, then carry and
\ [osc0] are added to output-buffer
: mix-xmod
    osc-bus @ rot>>c output<c
              rot>>c output-buffer ++! ;

: mix-silence
    0 output-buffer ! ;

: mix-osc1
    osc-bus @ rot>>
    output-buffer ! ;
    
\ compute output from oscillator bus depending on synth algo.
: mix
    synth @ mixer route
	mix-silence .,  
	mix-xmod .,     \ OSC0 xor OSC1 xor OSC2
	mix-reso .,     \ OSC0 xor (OSC1 and OSC2)
	mix-osc1 ;      \ OSC1

	
    




    


 macro
: do-isr | reg bit word |
    reg bit high? if
        reg bit low
        word run 1 retfie
    then ;
    
\ : m2>     m-swap m> ;
\ : m2>word m-swap m>word ;   
  
\ : do-isr    
\     >m     \ word >m
\     >m >m  \ flag >m
\     m-2dup
    
\     m> m> high? if  \ note that 'if' uses compile stack
\ 	m2> m2> low
\ 	m2>word 1 retfie
\     then ;
forth    
  
: isr
    OSCF-flag ' fixed do-isr
    
    OSC0-flag ' osc0  do-isr
    OSC1-flag ' osc1  do-isr
    OSC2-flag ' osc2  do-isr
    
    reset  \ fallthrough

    
\ same design as sheepsint: square wave oscillators with sync here,
\ oscillator events come from system timer events restart before
\ 'click' since restart is a constant delay. sync reset after all the
\ rest.


\ main sync source    
: osc0
    restart0
    bus:0 toggle 

    synth sync:0->1 high? if reset1 bus:1 high then
    synth sync:0->2 high? if reset2 bus:2 high then

    bus>audio ;

\ formant frequency or noise    
: osc1
    restart1
    synth osc1:noise high? if
	rand>c c? if bus:1 high else bus:1 low then
    else
	bus:1 toggle
    then

    synth sync:1->2 high? if
	reset2 bus:2 high
    then

    bus>audio ;

\ resonance    
: osc2
    restart2
    synth sync:0->2 high? if
	bus:2 low     \ if synced to 0, do one shot
    else
	bus:2 toggle  \ else just osc
    then  

    bus>audio ;
    

\ the fixed rate interrupt by default runs at FOSC/256, which is 7812
\ Hz. this increments a 32bit timer that can be used for control
\ sync. use PER2 to set the frequency to FOSC/(PER2+1)
    
: fixed
    dup WREG subwf  \ 0 stc
    dup tick0 ++!
    dup tick1 ++!
    dup tick2 ++!
        tick3 ++! ;




\ enable everything except the global interrupt flags which are used
\ to switch the synth on/off
    
: init-timers

    INTCON2 TMR0IP high \ TMR0: high priority    
    #x3 IPR1 !          \ TMR2IP, TMR1IP high pri
    2 IPR2 !            \ TMR3IP high pri
    #x88 T0CON !        \ TMR0: on, internal, 16bit, no prescale
    #x81 T1CON !        \ TMR1: 16bit reads, no scaling
    #x04 T2CON !        \ TMR2: no scaling
    #x81 T3CON !        \ TMR3: 16bit reads, no scaling
    RCON IPEN high      \ enable priority levels
    #x3F PR2 !          \ TMR2 period (31.25 kHz)
    ;

: ion    
    #x60 INTCON !       \ TMR0IE and PEIE high, GIE and TMR0IF low
    0 PIR1 !            \ clear  TMR1IF, TMR2IF
    3 PIE1 !            \ enable TMR1IE, TMR2IE
    0 PIR2 !            \ clear  TMR3IF
    2 PIE2 !            \ enable TMR3IE
    sti ;
    
: ioff
    INTCON TMR0IE low
    0 PIE1 !
    0 PIE2 ! ;


\ individual interrupt enables

: ioff-0  OSC0-enable low ;
: ioff-1  OSC1-enable low ;
: ioff-2  OSC2-enable low ;
: ioff-f  OSCF-enable low ;   

: ion-0   OSC0-enable high ;
: ion-1   OSC1-enable high ;
: ion-2   OSC2-enable high ;
: ion-f   OSCF-enable high ;    


    
    
\ FIXME: programming enables interrupts
: _engine-on
: engine-on
    init-timers         \ setup 18f hardware timers
    init-rand           \ setup lfsr RNG
    init-out            \ seup audio output
    ion ;

: _engine-off
: engine-off ioff ;

    

\ sheepsint control module


\ CONTROL


\ OSCILLATOR PERIOD

\ Convention: All words starting with underscore consume and/or
\ produce 16bit values.
    
\ simple synth configs. note:
\   - need to disable interrupts during period update.
\   - the single byte access uses 'dup' to obtain #x101 *
\   - before writing, periods are negated, so we can work with unsigned values
\   - dup/drop trick to keep interrupts enabled one more cycle

\ need to limit period size to acceptable value to avoid rollovers or
\ simply to fast interrupt rates that cause lockups. require the period
\ to be > #xFF, meaning the high byte cannot be zero.


: clamp/inv   0 xor z? if drop drop 0 1 then  \ fall into 2inv
: 2inv        INDF0 comf d=reg #xff xor ;

macro
: per! | var |
    clamp/inv
    cli
    var 1 + ! dup
    var !
    sti drop ;
\     >m m-dup
\     clamp/inv cli
\     m> 1 + ! dup
\     m> ! sti drop ;

: per@ | var |
    var @
    var 1 + @
    2inv ;
    
\     >m m-dup
\     m> @ m> 1 + @
\     2inv ;
forth
  
: p0 dup : _p0 posc0l per! ;
: p1 dup : _p1 posc1l per! ;
: p2 dup : _p2 posc2l per! ;


: _p0@ posc0l per@ ;
: _p1@ posc1l per@ ; 
: _p2@ posc2l per@ ;




\ PRESET SYNTH PATCHES

\ The way to construct a synth byte is to start with the mixer number,
\ and then set bits using the 'bit' word.
    

macro
: bit 1 swap <<< or ;    \ inbyte n -- outbyte   | set bit number n
forth
    
: _square    
: square
    mix:xmod
    sync:0->1 bit
    sync:0->2 bit synth !

    -1 p1 -1 p2 ;  \ disabled.

: _xmod2    
: xmod2
    mix:xmod
    sync:0->2 bit synth !

    -1 p2 ;       \ disabled

: _xmod3    
: xmod3
    mix:xmod synth ! ;

: _rxmod    
: rxmod
    randbyte p0
    randbyte p1
    randbyte p2
    xmod3 ;


\ what about chord?   0->1->2 ?    

: _>x >x >x ;
: _x> x> x> ;    

: pwm dup
: _pwm
    xmod2
    _>x _p0@
    _x> _- _p1 ;  \ add modulation frequency


: _noise    
: noise
    mix:osc1
    osc1:noise bit synth !
    -1 p0  \ disabled
    -1 p2
    1 p1 ; \ +- 8 kHz



load double-math.f   \ 16 bit math routines
load double-hacks.f  \ some optimized ones
    
: reso
    mix:reso
    sync:0->1 bit
    sync:0->2 bit synth !

    _p0@ 
    _>> _dup _p2     \ half max reso
    _>>      _p1 ;   \ reso freq 4x
    

: silence 0 synth ! ;    

\ NOTE
    
\ A4 above [middle] C4 is 440Hz
\ this makes C5 = 440 2 sqrt sqrt *

\ the lowest frequency that can be obtained at 2 MIPS with 2^16
\ subdivision is 30.517578 Hz, which is a little lower than C1 at
\ 32.703194 so the magic numbers are based on

\ C1 = 61156

\ there are 2 words used here. 'note' computes a note, while 'octave'
\ sets the current octave. the word 'bass-note' computes the lowest
\ octave (starting from C1)

\ load metaprogramming stuff in badnop namespace    
\ [ badnop (synth meta) use ]


\ require pic18/geo.ss  \ geo-seq macro

: bass->period
    23 min _table   \ 2 octaves, more convenient..
    
    61156      \ start
    dup 4 /    \ endx
    24         \ nb of items
    geo-seq    \ compile geometric sequence



variable oct
  
: _note
    drop \ drop high byte
: note
    bass->period
    oct @ nz? if
	for _>> next
    else
	drop
    then
    ;

: _octave
    drop \ ignore high byte
: octave
    oct ! ;

\ bound to some oscillator
: note0 note _p0 ;
: note1 note _p1 ;
: note2 note _p2 ;

\ 8 bit fetch for simple effects
: p0@  _p0@ nip ;
: p1@  _p1@ nip ;
: p2@  _p2@ nip ;

    
    
\ CONTROL TIMER

\ the fixed rate will increment a 32bit 'tick' counter once every
\ cycle. this counter can be used as a timer for the control rate
\ synchronization.

\ the fixed interrupt (with cpu at 2 MIPS) runs at 7812 Hz, and
\ increments a counter that can be used for longer time
\ intervals. From this we'll derive 2 standard sync timers: control
\ rate and note rate, at about 200 Hz and 8 Hz

\ to sync, first wait for a bit to go low, then wait for it to go
\ high. the different tick bits give

\ tick0 0   3906   Hz
\       4    244   Hz
\ tick1 1      7.6 Hz


\ FIXME: rewrite with lex params    
    
macro
: tickbit | bit |
    tick0 bit 3 >>> +   \ tick + byte address
    bit 7 and ;         \ bit address

: sync-tick | bit |
    begin bit tickbit low? until
    begin bit tickbit high? until ;
	
forth

\ these have changed + it's better to use tasks
\ : wait-note    9 sync-tick ;  \ 7.8 Hz
\ : wait-control 4 sync-tick ;  \ 244 Hz
    


\ TRANSIENTS + EFFECTS

\ words here will sync to control rate. transients that use
\ oscillators should save the frequencies in addition to synth config.

: s>x  synth @ >x ;
: x>s  x> synth ! ;

: p0>x _p0@ _>x ;  : x>p0 _x> _p0 ;
: p1>x _p1@ _>x ;  : x>p1 _x> _p1 ;
: p2>x _p2@ _>x ;  : x>p2 _x> _p2 ;

\ transient noise burst, used for hihat / snare
: burst
    s>x noise
    for 2 sync-tick next
    x>s ;
    
\ PANEL


load ad.f
load synth-panel.f

macro
: andor! | reg | reg and! reg or! ;
    \ >m m-dup m> and! m> or! ;
forth  

: param

    \ first 3 pots set period
    
    0 ad@ p0
    1 ad@ p1
    2 ad@ p2

    \ pot nb 3 is [ synth:2 noise:1 ignored:5 ] 
    
    3 ad@ #b11100000 and
    rot<< rot<<

    #b01111100 synth andor!
    
    \ pot nb 4 sets sync bits

    4 ad@ #b11100000 and
    rot<<

    #b10001111 synth andor!

    ;

#lang staapl/purrr

macro

: broem 1 2 mexit 4 5 ;  

: knip sym label ;

forth

: shama 123 >m m> ;

: bla 1 knip 2 knip 3 ;
: def 5 6 7 ;

    

: rec 123 rec ;

: eekhoorn broem broem ;

variable la
2variable lala
  

\ 16bit multiplication (global temp)

variable R0
variable R1
variable R2
variable R3

variable X0
variable X1
variable Y0
variable Y1

  
\ load the core multiplier routine which binds to the global temp
\ variables above
  
load mul16.f

: YX!  Y! X! ;
: R@   RL@ RH@ ;
  
: _umul  YX! umul>R R@ ;   \ unsigned, double
: _smul  YX! smul>R R@ ;   \ signed, double

: _fumul YX! umul>R RH@ ;  \ unsigned, fixed

    
: _*  \ signed, single word
    YX! smul>R
    RL@ ;  

: _*s \ signed, single word, saturated
    YX! smul>R
    R-saturate-signed ;

\ signed fractional. instead of keeping 1:0, we keep 2:1. same logic,
\ different registers.

\ single lookup table: works like 'route' but returns a byte

: table       \ index
    TOSL +!     \ add offset to return address
    0 TOSH ++!  \ add carry flag
    
    TOSL @ fl !  \ r>f  NOTE: this messes up the VM
    TOSH @ fh !

    pop
    @f+ ;

\ create a circular buffer in a 16 byte RAM line.

\ 1 state var, 1 guard byte. state vars are packed: high nibble =
\ read, low nibble = write the created word loads the a reg with the
\ buffer body. these words need current buffer in a reg.  

\ a -> [ read | write ], 15 buffer bytes

\ in order to distinguish empty from full, one guard byte is used. so 14 = full



: buffer:read
    @a #xf0 and nswap @i         \ fetch next item
    @a #x10 + c? if #x10 + then  \ update ptr
    !a ;                         \ store
: buffer:write
    @a #x0f and !i                          \ store next item
    @a nswap #x10 + c? if #x10 + then nswap \ update ptr
    !a ;

: buffer:clear  #x11 !a ;  \ clear buffer


: buffer-size \ [ read | write ]
    dup #xF0 and >x
    nswap #xF0 and
    x>  -
    nc? if #x10 - then nswap ;   DOES-NOT-WORK
    
: buffer:size  @a buffer-size ;


\ simple fast ringbuffer


variable read-ptr
variable write-ptr
#x0F constant buffer-mask  

: buffer:read
    read-ptr @ buffer-mask and i@  \ fetch
    1 read-ptr +! ;                \ increment

: buffer:write
    write-ptr @ buffer-mask and i! \ store
    1 write-ptr +! ;
    

\ old patch stuff
: wait0 for 0 for next next ;    
: wait1 for 0 wait0 next ;



variable _octave
: o! note _octave @ for _>> next _p0 ;

    

: z0 \ x --
    for randbyte 7 and octave ! randbyte o! 50 wait0 next ;

: z1 \ x --
    for
	randbyte 3 and octave !
	randbyte o!
	randbyte pwm
	50 wait0
    next ;
 
: z2 \ x --
    for
	randbyte #x3f and 1+ z1
	randbyte #x3f and 1+ wait0
    next ;

    
: wioew     100 pole ! square 3 p0 10 P++ ;


: rrxmod  randbyte for rxmod 50 wait0 next ;

: nzwioew  for 10 z2 wioew next ;    
    
: C 0 o! ;
: D 2 o! ;

\ demo words


: iiuu   1 p0 square 100 pole ! 100 P+ ;
: woe    100 p0 square 50 pole ! 100 P+ ;

: iiuwoe for iiuu woe next ;   

    
    
    
\ transient controller

\ code that runs at control rate is not nearly as time-critical as code
\ that runs at synth rate, though most things you'd want to at this rate
\ are still fairly simple timbre modulations.

\ one of those is transient sounds, like small noise bursts or
\ beeps. since we can't really mix sounds, we're going to mute the more
\ stable background tones whenever a transient occurs. when the
\ transient is done, all the synth params that were changed will be
\ restored from data pushed to the transient stack after the transient
\ counter is done.


\ testing

: pole+ _p0@ pole @ 0.0pole+ _p0 ;
: pole- _p0@ pole @ 0.0pole- _p0 ;

: P+  for pole+ 0 for next next ;
: P-  for pole- 0 for next next ;

: P++ for 0 P+ next ;
: P-- for 0 P- next ;


: Q+  for pole+ 10 for next ;
: Q++ for 0 Q+ next ;

\ core multiplier routine, it computes:
\ (X0 + X1 z) (Y0 + Y1 z) = R0 + R1 z + R2 z^2 + R3 z^3
\ with z = 2^8

\ the names can be bound to global variables, or local variables if
\ the extended instruction set is used.


\ the routine is almost straight from the data sheet DS39605C p72

macro

: Y! Y1 ! Y0 ! ;
: X! X1 ! X0 ! ;

: X@ X0 @ X1 @ ;
: Y@ Y0 @ Y1 @ ;
    
: RL@ R0 @ R1 @ ;
: RH@ R2 @ R3 @ ;
  
: mulcross    
    PRODL @ R1 +!
    PRODH @ R2 ++!
    0 R3 ++! ;


forth

: umul>R 

    X0 @ Y0 mulwf        \ low terms
    PRODL R0 movff
    PRODH R1 movff drop

    X1 @ Y1 mulwf        \ high terms
    PRODL R2 movff
    PRODH R3 movff drop

    X1 @ Y0 mulwf drop mulcross \ cross terms
    X0 @ Y1 mulwf drop mulcross
    ;
    

\ signed multiplication.

\ suppose X1 is negative. in that case, what we're computing using the
\ unsigned multiplication is actually

\   (X0 + (z + X1) z) (Y0 + Y1 z) 

\ this has a term z^2 (Y0 + Y1 z) too much in the result, which needs to
\ be subtracted. same goes for Y1 being negative.
    
    
    
: smul>R
    umul>R

    X1 7 high? if
	Y0 @ R2 -!
        Y1 @ R3 --!
    then

    Y1 7 high? if
	X0 @ R2 -!
        X1 @ R3 --!
    then ;

: R-saturate-signed 
    R3 @ \ save highest byte

    \ get sign bit of low word (+) -> 0, (-) -> 1
    R1 @ rot<< 1 and 

    \ add it to upper word

    \ using machine language here because 'drop' influences the zero
    \ flag, and it's a bit hard to juggle in forth.

    R2 addwf d=reg z? if
        0 movlw
        R3 addwfc d=reg z? if
            \ now R3:R2 contains zero -> no saturation
            R0 INDF0 movff
            R1 movf ;
        then
    then

    \ drop WREG scratch reg, and get saved highest byte
    drop
    
    \ otherwise return maximum int from sign bit
    rot<<c c? if
        drop #x00 #x80 ;
    then
        drop #xFF #x7F ;


    
    

\ vectored execution. this needs execute.f

\ the vector representation used BYTE ADDRESSES, however, this is
\ abstract.

\ perform execution given a variable address: extra level of indirection
macro    
: 2@ dup >m @ m> 1 + @ ;
: 2! dup >m 1 + ! m> ! ;    
: invoke 2@ execute/b ;
: ->  do-arrow stub ;    
forth

\ implementing this word as a macro leads to too much code, so i'm
\ using indirect addressing. 
: do-arrow
    0 a!!
    TOSL @ !a+
    TOSH @ !a+
    pop ;

    

\ Message buffering for a shared bus architecture. The topology looks
\ like this:

\                            wire
\                              |
\                              | G
\         A             E      v      F
\  wire ----> [ LRX ] ----> [ LTX ] ----> wire
\                |             ^
\  . . . . . . . | B . . . . . | D . . . . . . .
\                v      C      |
\             [ HRX ] ----> [ HTX ]
\
\ Code above the dotted line runs with interrupts disabled, and
\ pre--empts the code below the line. Communication between the two
\ priority levels uses single reader - single writer buffers. The 6
\ different events are:
\
\ A) PIC hardware interrupt
\ B) RX buffer full condition
\ C) TX buffer full condition (execute task which writes to buffer)
\ D) wakeup lowlevel TX task from userspace
\ E) wakeup lowlevel TX task from kernelspace
\ F) PIC hardware send
\ G) wakeup lowlevel TX task from bus idle event
\
\ A task is an 'event converter'. The 4 different tasks are:
\
\ LRX) convert interrupt (A) to tx buffer full B and tx wakeup E
\ HRX) convert tx buffer full (B) to rx buffer full (C)
\ HTX) convert tx buffer full (C) to tx wakeup (D)
\ LTX) convert wakeup (data ready: D,E) to hardware send.
\
\ The pre--emption point is A: this causes no problems for the
\ low--priority task because of the decoupling provided by the receive
\ buffer. The only point that needs special attention is the LTX task,
\ which can be woken up by different events D, E and G, and care needs
\ to be taken to properly serialize message handling. To do this, both
\ D and E should invoke LTX with interrupts disabled. For E this is
\ trivial: just call the LTX task, for G is is already ok since it's
\ an isr, so D needs to explicitly disable interrupts.
\



\ uses the following generic operations
\
\     ready?      \ -- ?
\     read        \ -- byte
\     write       \ byte --
\

macro

: or; not if exit then ;

\ transfer bytes from one object to another + exit current word when
\ done. the 'exit' bit is a poor man's break: it's easy to escape from
\ a nested control structure using the return stack, since compilation
\ stack and return stack are independent (but serve somehow the same
\ purpose).
    
: transfer; src dst | \ --
    
    begin
	' ready? src msg or;
	' ready? dst msg or;
	' read   src msg
	' write  dst msg
    again

    ;
forth

 



\ macro
\ : rx-message ? 0 0 high? ; \ complete highlevel message received  

\ forth  


\ : lowlevel-rx
\     buffer-rx-byte  \ read byte from device
\     begin tx-message? while
\ 	    dispatch-message
\     repeat
\     highlevel-tx ;  \ check if there are remaining messages to send

\ : lowlevel-tx
\     begin tx-message? while
\     repeat
    

\ \ After full reception of a message, the handling code is called. This
\ \ might do more dispatching based on the contents of the message.

\ : dispatch-message ;



    
\ : highlevel-tx ;   

\ conditional
: _choose
    _>r _>r
    or z? if drop   _rdrop _r> ;
        then drop   _r> _rdrop ;

\ quoted program
: _quot  2 fl @ +
         0 fh @ ++ ;
    


  
\ quotation.. the construct { A B C } has the runtime behaviour:
\ 1. load address of the composite function
\ 2. jump over the code

\ jumping can be eliminated by compiling the composite code after the
\ containing word, however, it's probably easier to juse use a parsing
\ word that compiles a jump over the quoted code for simple on-target
\ compilation.

\ CORDIC

\ The core routines in cordic are conditional addition and subtraction
\ of two registers A and B.


\ CORDIC needs a barrel shifter. It's probably easiest to implement
\ this using the multiplier. The shifts happen one after the other, so
\ the shift count can be stored in a register.

\ To implement a cartesian->polar conversion a table of angles is
\ necessary. Then rotation is done iteratively, conditionally on the
\ sign of the Q, while a tan(a) a = s2^(-n) increment will be added to
\ an angle accumulator. Note that the first comparison is on the sign
\ of I.

variable shift-scale

  
2variable I  2variable Is
2variable Q  2variable Qs  


\ Use current shift to fill Is and Qs with shifted versions.  
: cordic-shift
  

: bits \ n --
    table
    128 , 64 , 32 , 16 ,
      8 ,  4 ,  2 ,  1 ,

: shift-right   \ byte bits --
    shift-scale 
    
    

\ Generic interface for byte receiver-transmitter systems.

\ pc is short for "prefix compile" wich combines two symbols into a
\ name which is then compiled. This is the most minimal name space
\ management that is still useful to create some form of generic
\ algorithms.

macro
: rx-ready?  ' rx-ready? pc ;  \ class -- ?
: tx-ready?  ' tx-ready? pc ;  \ class -- ?
: >tx        ' >tx pc ;        \ byte class --
: rx>        ' rx> pc ;        \ class -- byte
: >tx        ' >tx pc ;        \ byte class --
: rx>        ' rx> pc ;        \ class -- byte
forth

  

\ double word math 8 -> 16 bit


\ some 16bit math routines. i don't have time for it now, but at this
\ point, a 16 bit forth would come in handy. all math on periods is
\ unsigned.
    
: _dup    over over ;

: _2drop _drop
: _drop  drop drop ;
    
: _nip    >x >x drop drop x> x> ;    
: _<<     clc 2nd rot<<c! rot<<c ;
: _>>     >> 2nd rot>>c! ;        \ unsigned
: _2/     2/ 2nd rot>>c! ;        \ signed

: _+               \ ( a b c d ) ( )
    >x swap>x      \ ( a c )     ( b d )
    + x> x- @ ++ ;

: _-
    >x swap>x      \ ( a c )     ( b d )
    - x> x- @ -- ;

: _invert
    WREG comf d=reg
    2nd comf d=reg ;


\ these leave carry flag intact, but not the zero flag
: _1+
    dup >x
    1 movlw INDF0 addwf  d=reg
    0 movlw INDF1 addwfc d=reg
    drop x> ;
    
: _1-
    dup >x
    -1 movlw INDF0 addwf  d=reg
             INDF1 addwfc d=reg
    drop x> ;
    


: _negate
    _invert
    _1+ ;

    
\ revised routines

: 2hi>x >x swap>x ;
: _and  2hi>x and x> x> and ;
: _xor  2hi>x xor x> x> xor ;
: _or   2hi>x or  x> x> or ;


\ combine low parts of 16 bit words into one 16bit word
: _lohi >x drop drop x> ;    

macro
: lohi | val | val val 8 >>> ;
: 2@   dup >m @ m> 1 + @ ; \ addr -- lo hi
: 2!   dup >m 1 + ! m> ! ; \ lo hi addr --   
forth

\ UNSIGNED 8 BIT -> 24 BIT REAL x COMPLEX MULTIPLY ACCUMULATE

\ This implements the core loop and offset correction routines for an
\ inner product using unsigned multiplication.

\ The 'mul/acc' routine reads the next complex filter coefficients (2
\ unsigned bytes) from flash memory, pointed to by the 'f' register.

macro

\ Note it is possible for the accumulator to overflow if the number of
\ taps exceeds 256 (one byte headroom). This is not a problem as long
\ as the eventual accumulation result fits in the 24 bit word length.
  
\ acc --  
: PROD-accumulate | acc |
    PRODL @ acc +!
    PRODH @ acc 1 + ++!
          0 acc 2 + ++!
;

\ Read the next filter coefficient
: coef> @f+ ;
    
\ value acc --
: mac-u8xu8-24 | acc |
    coef> umul>PROD
    acc PROD-accumulate ;

\ value acc --
: mac-dc-16 | acc |
      acc     +!
    0 acc 1 + ++! ;
    
\ Accumulator offset correction for 8 bit FIR coefficients centered at
\ #x80 (flipped sign bit). The most straightforward way is to shift
\ the complex accumulator left one bit, which sets center at #x100, a
\ byte border.

\ acc --
: 3<<! | acc |
    clc acc     rot<<c!
        acc 1 + rot<<c!
        acc 2 + rot<<c! ;

\ DC compensation: subtract a 2 byte value from the 3 byte accumulator.
: -dc! | acc dc |
    dc     @  acc 1 +  -!
    dc 1 + @  acc 2 +  --! ;

\ This converts the contents of the accumulator to a signed value,
\ using the dc accumulator. Note the accumulator has been shifted left
\ one bit.
    
: acc-correct | acc dc |
    acc 3<<!
    acc dc -dc! ;


: 2clear | acc |
    0 acc !
    0 acc 1 + ! ;

: 3clear | acc |
    acc 2clear
    0 acc 2 + ! ;
    
forth  

\ double lookup table: works like 'route' but returns 2 bytes.

: _table       \ index
    rot<<      \ word addressing (hide MSB in LSB)
    dup
    TOSL +!      \ add offset to return address
    1 and      \ recover high bit
    TOSH ++!     \ add carry flag and
    
    TOSL 0 low   \ clear the hidden MSB
    
    TOSL @ fl ! 
    TOSH @ fh !

    pop
    @f+ @f+ ;

    

load boot.f         \ init code
load serial.f       \ serial port driver
load interpreter.f  \ command interpreter
load string.f       \ support for flash buffers

load mem.f          \ generic fetch

load prom.f         \ flash programming driver
load route.f        \ support for the 'route' dispatch macro

\ these need to be procedures so they can be overridden by either
\ procedures or macros. (currently macros cannot be overridden by
\ procedures). FIXME: solve redirect inefficiency in asm optimization.

macro
: receive    async.rx> ;
: transmit   async.>tx ;
: console-on ;
: console-off ;
forth

#lang staapl/pic18

: broem 10 for0 1 + next0 ;

: woink  ' broem address 1 + 100 + ;    

: broem?  z? if 123 ; else 567 then ;
    
: exits  ; ; ; 
    
: wakka 1 + wakka ;    
: bla 1 2 3 ; 4 5 6 ;
: inc 1 - 2 - ;

variable abc

\ macro
\ : install-vec  8 org-push wakka exit org-pop ;
\ forth
\ : dummy install-vec ;

load mac-u8xu8.f

\ The macros above are used to instantiate a mac routine using a
\ global complex 2x24 bit accumulator.

2variable acc-i variable hr-i  \ inphase    (real)
2variable acc-q variable hr-q  \ quadrature (imaginary)

\ An extra accumulator, used for computing offset correction terms due
\ to unsigned multiplication.

2variable acc-dc

\ needs to be independent of 'a' register, and fast
: clear-acc
    acc-i  3clear
    acc-q  3clear
    acc-dc 2clear ;

\ The filter loop, reads 8 bit unsigned coefficiens from ram (real)
\ and flash (complex), using the 'a' and 'f' registers.

\ n --
: fir-loop
    for
        @a+  \ input data stored in ram
        dup acc-i  mac-u8xu8-24  \ real
        dup acc-q  mac-u8xu8-24  \ imaginary
            acc-dc mac-dc-16     \ average (for DC compensation)
    next ;


: fir-correct
    acc-i acc-dc acc-correct
    acc-q acc-dc acc-correct ;


\ Main filter routine. This requires 'a' and 'f' registers to be set
\ to the unsigned signal and #x80-centered unsigned filter
\ coefficients.

\ n --
    
: fir
    clear-acc
    fir-loop
    fir-correct ;

macro
: u, #x80 + , ;  
forth  
    
\ Test routines
\ : average f->
\     1 u,  1 u,
\     2 u, -1 u,
\     2 u,  1 u,
\     1 u, -1 u,

\ : input
\     #x40 0 a!! ;


\ test can be:  
\    1 #x80 + init-test
\    input average 4 fir    


\ : n!a
\     for dup !a+ next drop ;

    
\ : init-test \ value --
\     input #x40 n!a  \ set buffer to all 1s, dc shifted
\     ;

\ chip constants
load p18f1220-const.f

macro
  
: serial-div 16 ;

\ chip config macros for core code

\ FIXME: should i set chip pins to output? according to johannes
\ inputs shouldn't hurt.

: init-chip
    -1 LATB !        \ prevent TX pin glitch
\   2-output         \ 2 ports, all output
    #x70 OSCCON ! ;  \ internal oscillator at 8MHz



\ Detect the presence of a serial cable by detecting an IDLE state
\ (high) on RX (RB4). Tie the pin low using 100k to default to BREAK
\ with no cable connected, or jumper it.

\ On a Power-on Reset, RB4:RB0 are configured as analog inputs by
\ default and read as 0; RB7:RB5 are configured as digital
\ inputs. This means we need to set ADCON1 to check the debug state.

\ This macro is then only valid AFTER initializing the serial port,
\ which sets the inputs to digital.
    
: debug-serial?
    PORTB 4 high? ;
    

    
: init-serial
    ADCON1 5 high ADCON1 6 high  \ pins
    TRISB 4 high TRISB 1 high
    init-serial-baud-8           \ baud rate
;

forth

  

\ Macros for handling and initializing interrupts on PIC18
\ hardware. This is tested on 18F1320 and 18F2620

macro  

\ DISPATCH
  
: ack/dispatch | iflag isr |
    iflag compile high? if
	iflag compile low
	isr compile
	1 retfie
    then ;

\ GLOBAL

\ The following macros are orthogonal. The final command to switch on
\ interrupts is always sti, which is defined elsewhere as "INTCON GIE
\ high". The global contract: macros for specific devices ONLY access
\ their own flags, not the global interrupt enable.
    
: interrupt-init    
    RCON IPEN high       \ enable priority levels
    INTCON PEIE high     \ enable peripheral interrupts
;    
\ TMR2

: tmr2-ie PIE1 TMR2IE ;
: tmr2-if PIR1 TMR2IF ;

\ FIXME: doesn't set PR2    
: tmr2-init

    IPR1 TMR2IP high    \ high priority interrupt
    #x04 T2CON !        \ no scaling, timer on
    \ #x3F PR2 !          \ TMR2 period (31.25 kHz)
    \ #xFF PR2 !          \ debug: slower
    0 TMR2 ! ;
    
: tmr2-on  tmr2-if low tmr2-ie high ;
: tmr2-off tmr2-ie low ;
    
\ INT0    

: int0-ie INTCON INT0IE ;
: int0-if INTCON INT0IF ;

: int0-init \ FIXME: piggybacks on tmr2-init
    INTCON2 INTEDG0 high   \ rising edge
    ;

: int0-on  int0-if low int0-ie high ;
: int0-off int0-ie low ;

    
forth

\ standard forth conditionals not using the flags. these are less
\ efficient than the flag macros, but easier to use. best to use these
\ if code is not time critical.

: >z   0 + nfdrop ;  \ used in 'cbra' macro as fallback

macro
: ~cmp  | y n i |
    POSTDEC0 i compile
    n retlw
    y retlw ;
forth  

: =  -1  0 ' cpfseq ~cmp
: >  -1  0 ' cpfsgt ~cmp
: <  -1  0 ' cpfslt ~cmp
: <=  0 -1 ' cpfsgt ~cmp
: >=  0 -1 ' cpfslt ~cmp
    

\ port initialization CATkit board:
\ -- 5 analog inputs
\ -- 3 switch inputs with pullup
\ -- audio port output
\ -- pot net on/off output


\ notes

\ * since port initialization is a board feature, all inits, except
\ for the serial port, are concentrated here. it is OK to use some
\ chip macros for init though.

\ * AD inputs can be set individually. this is different than on the
\ 18f2550 for example, where you can only enable a contiguous range of
\ ports as analog inputs.

\ * to set an analog input, both digital input and output need to be
\ disabled. (see datasheet page 89, figure 10-2) the former is done by
\ clearing bits in the ADCON1 register (0 = analog in, 1 = digital
\ in), the latter is done by setting the TRIS bits, which disables the
\ output driver.


macro    

: init-CATkit-ports
    \ note that PGM is still configured as LVP. the pin is open so it
    \ needs pullups.

    #x1F TRISA or!    \ disable digital output for A0-A4
    TRISA 7 low       \ RA7 is output: potnet on/off switch

    #xE1 TRISB or!    \ analog 4 is RB0 + RB5-RB7 are digital in
    INTCON2 RBPU low  \ enable weak pullups for port B (switches)

    #x60 ADCON1 !     \ set A0-A4 as analog input (5,6 digital for serial port)
    #x7E ADCON2 !     \ AD: left justified, 20 TAD, fosc/2
;


: S1?   PORTB 7 low? ; 
: S2?   PORTB 6 low? ; 
: S3?   PORTB 5 low? ;    
    
forth

\ these are useful as interactive commands, so not defined as macros.  
: potnet-on  LATA 7 high ;
: potnet-off LATA 7 low ;   

\ board init, leaves serial port config alone.    
: init-board
    init-CATkit-ports
    potnet-on ;
    
    

\ chip constants
load p18f452-const.f

macro
  
: serial-div 16 ;

\ chip config macros for core code
: init-chip ;  \ nothing needed    




\ Detect the presence of a serial cable by detecting an IDLE state
\ (high) on RX (RB4). Tie the pin low using 100k to default to BREAK
\ with no cable connected, or jumper it.

\ On a Power-on Reset, RB4:RB0 are configured as analog inputs by
\ default and read as 0; RB7:RB5 are configured as digital
\ inputs. This means we need to set ADCON1 to check the debug state.

\ This macro is then only valid AFTER initializing the serial port,
\ which sets the inputs to digital.
    
: debug-serial?
    PORTC 7 high? ; \ FIXME: check this
    

    
: init-serial
    TRISC 7 high TRISC 6 low     \ pins
    init-serial-baud-8           \ baud rate
;

forth

  

\ ************************************************************************

\ a direct threading composite code interpreter. has a number of small
\ differences to standard forth. (the idea is this will run a version
\ of forth without parsing control words, but using quoted code instead).


\ *** CONTINUE will resume the execution of the VM, more specificly
\ the program pointed to by IP. a program is an array of primitive
\ instructions. primitive instructions are primitive code (word)
\ addresses + a continuation discard bit (EXIT bit). IP is implemented
\ by TBLPTR. (f register)

\ *** i want to express iteration using TAIL RECURSION. this means the
\ caller needs to pass the proper continuation to the callee on the
\ RETURN STACK, discarding the current thread if necessary. for this
\ purpose, one 'EXIT' bit will be reserved in the instruction field,
\ and the interpreter loop will pop the stack before calling the next
\ primitive.

\ *** a continuation can be invoked by RUN, so there is no distinction
\ between programs and continuations. a continuation takes a data
\ stack as argument, just like ordinary programs. (RUN is the dual of
\ forth's EXECUTE, which is used here to invoke primitives).

\ *** the machine return stack is reserved for the underlying STC
\ forth / machine code. the VM uses the STC aux stack x as return
\ stack, to limit interference.

\ *** to treat composite code as a primitive, an array of primtiive
\ instructions needs to be prefixed by a machine code element 'CALL
\ enter', which will save the current continuation (IP) and invoke a
\ new one. 'enter' needs to be duplicated if a large address space is
\ spanned, so a short branch can be used.

\ *** the interpreter is explicit: this is done so that primitives do
\ not need to end in NEXT, as is done traditionally. an explicit
\ interpreter loop enables the use of STC primitives, allowing better
\ interoperability with STC a and foreighn code. also, instead of
\ using real name spaces, all primitives are prefixed with '_'
\ (underscore) so they are easily mapped and debugged in STC forth.



\ TODO: some modifications.
\ - all data sizes used (literals, primitives, composite) fixed at 14bit
\ - interpreter runs on top of memory model: composite code in ram possible


\ ************************************************************************

\ IP + RS
\ instruction pointer manipulation. only the ones that affect the
\ machine return stack and machine flags need to be macros. the rest
\ can be functions for ease of debugging.

macro
: @IP+  @f+ ;  \ read bytes from the instruction stream
forth

: _IP!
    _<< fh ! fl ! ;   \ store to IP
  
: enter \ asm (rcall ENTER) wraps composite code in prim
    _IP>r
    TOSL fl @!  \ TOS cannot be movff dst, but src is ok       
    TOSH fh @!
    pop ;   
  
: _>r    >x >x ;
: _r>    x> x> ;    
: _rdrop xdrop xdrop ;


\ These 2 govern the format in which threaded addresses are stored on
\ the return stack. For return stack tricks to work, this is taken to
\ be word addresses.
    
: _IP>r              \ save current IP to VM RS
    clc
    fh @ rot>>c +x !
    fl @ rot>>c +x ! ;
    
: _r>IP              \ pop IP from VM RS
    clc
    x- @ rot<<c fl !
    x- @ rot<<c fh ! ;


\ INSTRUCTION FORMAT + INTERPRETER / COMPILER

macro

\ in flash, code is stored as [EXIT | LIT | DATA]. the shift left when
\ reading will move EXIT->carry and LIT->negative flags.

: exit?    c? ;
: literal? n? ;
: prim@/flags         \ fetch next primitive from composition
    \ clc             \ low bit is ignored by PIC
    @IP+ rot<<c        \ this sets c and n flags
    @IP+ rot<<c  ;

  
\ compilation macros. DTC is compiled by mapping it to native forth in
\ symbolic form. these macros implement the encoding.
  
: pow2      1 swap <<< ;
: set       pow2 or ;
: mask      pow2 1 - and ;
    
: exitbit   15 set ;
: litbit    14 set ;    
: mask14    14 mask ;

: _compile ,, ;                  \ word.addr --
: _exit    dw> exitbit  ,, ;
: _literal mask14 litbit   ,, ;  \ 
: _;       _exit ;

    
\ utility macros
: _c>>     rot>>c 2nd rot>>c! ;
: _<<c     2nd rot<<c! rot<<c ; 
    
forth
  
\ inner interpreter loop
: continue
    prim@/flags                 \ fetch next primitive + set type flags
    exit? if _r>IP then         \ c -> perform exit
    literal? if 14bit ; then    \ n -> unpack literal
    execute/b continue ;        \ execute primitive

\ interpret doubleword [ 1 | 14 | x ] as a signed value.
: 14bit
    _c>>                 \ [ x | 1 | 14 ]
    #x3F and             \ high bits -> 0  
    1st 5 high?
    if #xC0 or then      \ high bits -> 1
    continue ;    



: _execute  _<<              \ execute STC primitive, word address
: execute/b push TOSH ! TOSL ! ; \ ( lo hi -- ) execute STC primitive, byte address
    
: _bye      pop              \ quit the inner interpreter
: _nop      ;


    
\ trampoline entry. 'execute' will run a dtc primitive or primitive
\ wrapped program. not again that: PRIMITIVE = pointer to native code
\ (execution token passed to 'execute') , COMPOSITE = pointer to array
\ of execution tokens (program token passed to 'run')
    
: bye>x      enter ' _bye _compile _exit
: dtc           \ ( lo hi -- )
    bye>x       \ install continuation into dtc code "bye ;"
    execute/b   \ invoke the primitive (might be enter = wrapped program)
    continue ;  \ invoke threaded continuation
    

\ CONTROL FLOW WORDS

\ 'run' is the dual of 'execute'. it takes threaded code addresses. in
\ combination with the exit bit, this can be used to implement
\ conditional jumps.
    
: _run \ addr --
    _IP>r
    _IP! ;

\ : _0=run \ flag addr -- 
\     _run
\     or nz? if _r>IP then
\     drop ;


\ "go" = "run ;"    

\ i don't want to use the word 'jump', but conditional jump is not the
\ same as conditional run.
    
: _0=go  \ ? program --
    _>r
    or nz? if
	_rdrop
    else
	_r>IP
    then drop ;

    
macro

\ note: XT need to be word addresses, since i have only 14 bit
\ literals. return stack still contains byte addresses though, so for
\ now it's kept abstract.


: _m>literal   m> _literal ;
: _m>compile   m> _compile ;

\ create a jump label symbol and duplicate it (for to and from)
: _2sym>m      sym >m m-dup ;
    


\ jumps are implemented as literal + primitive (instead of reading
\ from instruction stream)
    
: _m>jmp    _m>literal ' _run   _compile _exit ;
: _m>0=jmp  _m>literal ' _0=go  _compile  ;    
    
: _begin    _2sym>m m> label ;   \ back label
: _again    _m>jmp ;             \ back jump
: _until    _m>0=jmp _space ;    \ conditional back jump
    
: _if     _2sym>m _m>0=jmp ;                  \ c: -- label1
: _else   _2sym>m _m>jmp m-swap m> label ;   \ c: label1 -- label2
: _then   m> label _space ;        \ c: label --

: _space  ' _nop _compile ; \ necessary when 'return' needs to be isolated.
    
\ : _for    _2sym>m m> label ' do-for _compile ; \ c: -- label
\ : _next   _m>literal ' do-next _compile _space ;

: _for
    ' _>r _compile
    _begin ;
: _next
    ' do-next _compile  _m>0=jmp
    ' _rdrop _compile
    _space ;
    
forth
: do-next \ -- ?
    _r> _1- _dup
    _>r _0= ;

\ -*- forth -*-


\ Boot code for PIC18 chips.


\ Misc  stuff to remember when configuring chip

\ - disable watchdog timer if the code does not use CLWDT
\ - set power up timer (or use capacitor + reset enabled)
\ - disable MCLR pin, or use a reset switch with pullup resistor



\ Data memory

\ Note that the extended 18f instruction set allows the use of indexed
\ addressing relative to FSR2, which can enable cheap structs/objects. 
\ however, it disables global (access bank) variables for the region
\ 0x000-0x05F, which makes that region better suited for stack memory
\ if the extensions are used, so the contiguous space after 0x80 could
\ be used as object memory, leaving the space 0x60-7F for global
\ variables.

\ in short, indexed addressing?
\ no  -> stacks in 0x80 - 0xFF, globals in 0x00 - 0x7F
\ yes -> stacks in 0x00 - 0x5F, globals in 0x60 - 0x7F

\ you'll have to configure this in a config seed, values are used below

\ note that bank selecting is not used. it sucks, one can do without


\ * INDF0 the data stack
\ * INDF1 the control/temp stack (x)
\ * STKPTR the hardware return stack (r)

\ redefine these:

\ : stack-data    #x80 ;
\ : stack-control #x90 ;


\ stack init code
macro
: init-rs
    0 movlw STKPTR movwf ;      \ RS  
: init-ds
    stack-data    1 - 0 lfsr ;  \ DS
: init-xs    
    stack-control 1 - 1 lfsr ;  \ CS
: init-stacks
    init-ds
    init-xs
    init-rs ;
forth

\ util
macro
: kHz  1000 * ;
: MHz  kHz kHz ;
forth

\ macros for chip setup. this needs to be cleaned up a bit.. but maybe
\ this approach is better even? all the setup code is defined in
\ macros, and you simply instantiate the macro in your boot code. all
\ nice and explicit.
  
\ these default to all output, which is good enough for testing.

macro

\ will be redefined when the correct machine is loaded
\ : TRISA undefined ;
\ : TRISB undefined ;
\ : TRISC undefined ;
\ : TRISD undefined ;
\ : TRISE undefined ;

: 2-output 0 TRISA ! 0 TRISB ! ;
: 3-output 2-output 0 TRISC ! ;
: 5-output 3-output 0 TRISD ! 0 TRISE ! ;
forth


\ The main idea of a boot loader during development is that it is
\ robust: it should be impossible to mess up the boot process while
\ poking around; it should always be possible to gain access to the
\ device through the built-in interpreter.

\ On the other hand, d\uring deployment, it should be possible to
\ erase or fuse the boot block to disable all access to the
\ interpreter.

\ The boot block should be universal enough so that it has to be
\ flashed only once. All unnecessary features need to be moved to
\ the application (or os kernel) source.

\ These requirements lead to the following solutions:

\ - booting never bypasses the debug check (serial idle / break)
\ - ISRs are passed to the block following the boot block
\ - first 64 K are clean of core code (to enable fusing)
\ - boot code is strictly read-only

  
\ Jump to boot loader, and install ISR patched to block at app-boot

app-boot org        : application
app-boot #x08 + org : isr-high
app-boot #x18 + org : isr-low
    
#x0000 org  : boot boot-40 ;
#x0008 org  : boot-isr-high isr-high ;
#x0018 org  : boot-isr-low  isr-low ;
  
\ It is possible to install a custom boot loader by overwriting block
\ 0.  For robustness, it is allowed for block 0 (the first 64 bytes ==
\ first flash erase unit) to be empty, meaning it contains only #xFFFF
\ NOP instructions. the code will fall into this word, at the start of
\ block 1.
    

#x0040 org    
: boot-40 warm ;

\ Boot loader code starts here.
    

  
\ Set the ram allocation pointer.
\ allot-ram  dict ram

\ FIXME: re-implemented as vector.f : basically the same, just using
\ standard variables instead of a separate hook page.

\ this is a simple mechanism for changing run-time behaviour. i know
\ at least 3 distinct forth mechanisms that implement this:

\ DEFER IS
\ VARIABLE EXECUTE @ !
\ DOER MAKE

\ the mechanism here is a variant of brodie's DOER MAKE (see Thinking Forth)

\ i try to keep it as simpel as possible.

\ 1. one hook table, enough for 128 hooks. hook identified by byte.
\ 2. no read functionality
\ 3. write functionality ala DOER MAKE

\ implementation: macros (so LFSR can be used) + clobbers a reg.


\ FIXME: this is hardcoded, do automatic alloc
1 constant hook-page     \ hooks will be stored here

macro
: ->       hook-page a!! !a-hook ; \ important word, so short rep
: run-hook hook-page a!! @a-hook ;
forth

: !a-hook
    TOSL @ !a+
    TOSH @ !a+
    pop ;

: @a-hook
    push
    @a+ TOSL !
    @a+ TOSH ! ;
  
\ EXAMPLE

\ 0 5  2constant bar

\ : foo  bar -> 1 2 3 ;
\ : baz  bar run-hook ;    

\ -*- forth -*-

\ loads the address following the call to 'f->' into f register, and
\ returns to the parent word. this allows flash buffers/strings to be
\ implemented as ordinary words

\ : mystring  f->  0 , 1 , 2 , 

: f-> \ -- 
    TOSL @ fl !
    TOSH @ fh !
    pop ;

\ a string is an fobject with the first byte = size of the remaining
\ bytes.

    

\ -*- forth -*-

\ This file contains bare bones task switching code, in the form of
\ the following words. It switches the 3 stacks and the a and f
\ registers.
\
\    suspend  \ -- task      | copy state to data stack, return task pointer
\    resume   \ task --      | ignore current context, resume old task
\    swaptask \ ta var -- tb | swap task ta with task stored in var
\
\ For example, using only two tasks, a single variable is used to
\ store the task pointer of the other state.
\
\    variable other
\
\ Which enables the definition of a simple yield word
\
\    : yield suspend other swaptask resume ;
\
\ In general, one would call a 'schedule' word which transforms one
\ task id into another one. For example by placing one task in a
\ queue, and reading the next one from the queue.
\
\    : yield suspend schedule resume ;
\
\
\ Booting a task is very simple. It requires the initialization of the
\ 3 stack pointers to an available location in memory. This depends on
\ the particual memory model an is left to the user.
\
\  : spawn
\	suspend other !   \ suspend current task
\	#x10 rp !         \ move return stack pointer to half of stack
\	#x50 xp !         \ similar for the other 2
\	#x60 dp !
\       init-task ;
\ 



\ IMPLEMENTATION

macro
: dp FSR0L ;
: xp FSR1L ;
: rp STKPTR ;    
forth

\ A task is represented by a data stack pointer. The tricky bits are
\ dp@ and dp! which must not interfere with the WREG = TOP
\ optimization we have going on. It turns out this is easy:
\
\ dp@ is just dp @, which is implemented as 'dup', followed by w <- FSR0L
\ dp! is also just dp !, implemented as 'w -> FSR0L' followed by 'drop'
\
\ Note that saving of a / f registers and TABLAT is only necessary if
\ you use them in all tasks. the first 2-task app i did indeed used
\ both a and f reg in both tasks, so here's the safest version.

\ Note: this saves only the low byte of the FSR address, so task
\ stacks need to be in the same bank.

macro
: dp@  dp @ ;
: dp!  dp ! ;    
forth


macro
: suspend  \ -- task
    TABLAT @ fl @ fh @ al @ ah @ rp @ xp @ dp@ ;
: resume   \ task --
    dp! xp ! rp ! ah ! al ! fh ! fl ! TABLAT ! ;
: swaptask \ task var --
    swap! ;  
forth



\ YIELD: M.W 3b: to surrender or relinquish to the physical control of another 

\ single byte fractional increment
: 00_+     swap>x + #x00 x- @ ++ ;
: ff_+     swap>x + #xFF x- @ ++ ;
: ss_+     WREG 7 high? if ff_+ ; then 00_+ ;  \ signed version
    
: _saturate+  drop drop -1 -1 ;
: _saturate-  drop drop 0 0 ;


\   fractional multiplication:  b a z -- x y
\   computes:  0.ab  1.0z *
\              0.ab  0.Fz *

\   factored into  0.ab 0.0z *  and an addition.
\   observe that the result is only 8 bits: [az]_h, which is
\   augmented by the carry bit of [az]_l + [bz]_h + #x80

\   last term is for proper rounding. note that instead of
\   adding #x80, it's possible to add a uniformly distributed
\   pseudorandom number with average #x80 to get better
\   average behaviour.

    
: 0.0z* \ b a z -- r
    POSTDEC0 mulwf  \ compute az  \ b z
    PRODH +x movff
    PRODL +x movff                  \ b z       \ az_h az_l
    POSTDEC0 mulwf drop             \           \ az_h az_l
    PRODH @ x- @ +                  \ bz_h+az_l \ az_h
    rot<< 1 and                      \ roundbit  \ az_h
    x- @ ++                         \ r         \
;


: 0.0pole+ \ b a z -- b+ a+
    _dup 0.0z* 00_+ ;
: 0.0pole- \ b a z -- b- a-
    _dup 0.0z* neg ff_+ ;

\ -*- forth -*-
: _route/e              \ clip to last
    min
: _route 
    rot<< dup TOSL +!	\ can use rot since LSB is ignored..
    1 and TOSH ++! ;	\ ..which enables us to use it here

macro
: route
    _route        \ proper call
    sym label: ;  \ avoids optimization into tail call
forth
  

\ -*- forth -*-

\ sheepsint is modeled after synth14 running on the pic12f628. a
\ simple 1 bit synth with 3 oscillators. this one is supposed to be a
\ bit more 'high quality'.

\ some (possible) additions compared to PIC12

\ * asynchronous: 3 hardware 16bit timers using interrupts, gives
\   higher 'sampling rate' for oscillators
\ * multiplier based exponential/sinusoidal modulation
\ * self-programming
\ * high level 'config forth'


\ 2 oscillator mixer configurations

\ * XMOD = XOR, with possible assymetric sync
\ * RESO = 0 AND [1 XOR 2], where 2 acts as an envelope (one-shot)


\ using the 4 timers:

\ TMR0 16bit OSC0 main osc
\ TMR2 16bit OSC1 noise / formant
\ TMR3 16bit OSC2 reso
\ TMR1 8bit  (fixed) control frequency


\ lowlevel dependencies:

load execute.f
load task.f
load vector.f
load _table.f   \ double lookup tables

\ application

\ load synth-panel.f

load synth-core.f
load synth-control.f
load synth-soundgen.f


\ TODO: control using the 16bit VM. see pic18/direct.f
\ load direct.f

\ macro
\ : synth-loop  \ word --
\     >m on
\     begin
\ 	cswap m>word
\ 	rx-ready?    \ stop looping when serial byte received
\     until
\     off ;  
\ forth  


\ Loop until byte received.  
\ : mainloop  ' param synth-loop ;

\ start application. this runs after the interpreter init is complete.

  
: main
    init-board     \ CATkit board specific inits
    engine-on      \ turn on syth engine (interrupts)

: mainloop
    param mainloop ;


macro

\ compile interrupt application and interrupt vector
: install
    #x0200 org-push main exit org-pop
    #x0208 org-push isr  exit org-pop ;
  
forth


\ don't install vectors by default
\ install
  

\ simple fast ringbuffer

\ more like an example since it's all early bound and i don't have a
\ proper way to abstract this kind of stuff.. if you need only one,
\ just load the file.

\ needs the following symbols defined. uses indexed addressing for the
\ buffer bulk.

\ variable buffer-read-ptr
\ variable buffer-write-ptr
\ #x0F constant buffer-mask

macro

: buffer-wrap
    buffer-mask and ;

: buffer-ptr@+
    @ postinc buffer-wrap ;

: buffer-read
    read-ptr  buffer-ptr@+ @i ;

: buffer-write
    write-ptr buffer-ptr@+ @i ;

: buffer-size
    write-ptr @
    read-ptr  @  - buffer-wrap ;
    
forth
